searchNodes=[{"doc":"Generates the required Txbox database migrations.","ref":"Mix.Tasks.Txbox.Gen.Migrations.html","title":"Mix.Tasks.Txbox.Gen.Migrations","type":"task"},{"doc":"Txbox is a Bitcoin transaction storage schema. It lets you store Bitcoin transactions in your application's database with searchable and filterable semantic metadata. Txbox is inspired by TXT but adapted to slot into an Elixir developers toolset.Built on Ecto! Store Bitcoin Transactions in your database and define associations with any other data from your app's domain.Built in queue for pushing signed transactions to the Bitcoin network via the Miner API.Auto-syncs with the Miner API of your choice, and caches signed responses.Aims to be compatible with TXT, with similar schema design and API for searching and filtering.Unlike TXT, no web UI or HTTP API is exposed. Txbox is purely a database schema with query functions - the rest is up to you.Coming soon (™) - Seamlessly import and export from other TXT-compatible platforms.InstallationThe package can be installed by adding txbox to your list of dependencies in mix.exs.def deps do [ {:txbox, &quot;~&gt; 0.3&quot;} ] endOnce installed, update your application's configuration, making sure Txbox knows which Repo to use.# config/config.exs config :txbox, repo: MyApp.RepoNext, add Txbox to your application's supervision tree.children = [ {Txbox, [ # Manic miner configuration (defaults to :taal) miner: {:taal, headers: [{&quot;token&quot;, &quot;MYTOKEN&quot;}]}, # Maximum number of times to attempt polling the miner (default is 20) max_status_attempts: 20, # Interval (in seconds) between each mAPI request (default is 300 - 5 minutes) retry_status_after: 300 ]} ] Supervisor.start_link(children, strategy: :one_for_one)Finally, run the following tasks to generate and run the required database migrations.mix txbox.gen.migrations mix ecto.migrateUpgradingIf upgrading from a previous version of txbox, make sure to run the migrations task to check if any new migrations are required.mix txbox.gen.migrations # If needed mix ecto.migrateUsageOnce up an running, using Txbox is simple. The Txbox modules provides four CRUD-like functions for managing transactions: create/2, update/2, find/2 and all/2.To add a transaction to Txbox, the minimum required is to give a txid.iex&gt; Txbox.create(%{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot; ...&gt; }) {:ok, %Tx{}}When a channel name is ommitted, transactions are added to the default_channel/0 (&quot;txbox&quot;), but by specifiying a channel name as the first argument, the transaction will be added to that channel. You can provide additional metadata about the transaction, as well as attach the raw transaction binary.iex&gt; Txbox.create(&quot;photos&quot;, %{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;, ...&gt; rawtx: &lt;&lt;...&gt;&gt;, ...&gt; tags: [&quot;hubble&quot;, &quot;universe&quot;], ...&gt; meta: %{ ...&gt; title: &quot;Hubble Ultra-Deep Field&quot; ...&gt; }, ...&gt; data: %{ ...&gt; bitfs: &quot;https://x.bitfs.network/6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110.out.0.3&quot; ...&gt; } ...&gt; }) {:ok, %Tx{}}The transaction can be retrieved by the txid.iex&gt; Txbox.find(&quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) {:ok, %Tx{}}As before, omitting the channel scopes the query to the default_channel/0 (&quot;txbox&quot;). Alterntively you can pass the channel name as the first argument, or use &quot;_&quot; which is the TXT syntax for global scope.iex&gt; Txbox.find(&quot;_&quot;, &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) {:ok, %Tx{}}A list of transactions can be returned using all/2. The second parameter must be a map/0 of query parameters to filter and search by.iex&gt; Txbox.all(&quot;photos&quot;, %{ ...&gt; from: 636400, ...&gt; tagged: &quot;hubble&quot;, ...&gt; limit: 5 ...&gt; }) {:ok, [%Tx{}, ...]}A full text search can be made by using the :search filter parameter.iex&gt; Txbox.all(&quot;_&quot;, %{ ...&gt; search: &quot;hubble deep field&quot; ...&gt; }) {:ok, [%Tx{}, ...]}Filtering and searchingTxbox adopts the same syntax and query modifiers used by TXT. Txbox automatically normalizes the query map, so keys can be specifiied either as atoms or strings. Here are a few examples::search - Full text search made on trasactions' tags and meta data%{search: &quot;hubble deep field&quot;}:tagged - Filter transactions by the given tag or tags%{tagged: &quot;photos&quot;} - all transactions tagged with &quot;photos&quot;%{tagged: [&quot;space&quot;, &quot;hubble&quot;]} - all transactions tagged with both &quot;space&quot; and &quot;hubble&quot;%{tagged: &quot;space, hubble&quot;} - as above, but given as a comma seperated string:from - The block height from which to filter transactions by%{from: 636400} - all transactions from and including block 636400:to - The block height to which to filter transactions by%{to: 636800} - all transactions upto and including block 636800%{from: 636400, to: 636800} - all transactions in the range 636400 to 636800:at - The block height at which to filter transactions by exactly%{at: 636500} - all transactions at block 636500%{at: &quot;null&quot;} - all transactions without a block height (unconfirmed)%{at: &quot;!null&quot;} - all transactions with any block height (confirmed):order - The attribute to sort transactions by%{order: &quot;i&quot;} - sort by block height in ascending order%{order: &quot;-i&quot;} - sort by block height in descending order%{order: &quot;created_at&quot;} - sort by insertion time in ascending order%{order: &quot;-created_at&quot;} - sort by insertion time in descending order:limit - The maximum number of transactions to return:offset - The start offset from which to return transactions (for pagination)Transaction state machine and miner API integrationUnder the hood, Txbox is packed with a powerful state machine with automatic miner API integration.When creating a new transaction, you can set its state to one of the following values.&quot;pending&quot; - If no state is specified, the default state is &quot;pending&quot;. Pending transactions can be considered draft or incomplete transactions. Draft transactions can be updated, and will not be pushed to miners unless the state changes.&quot;queued&quot; - Under the &quot;queued&quot; state, a transaction will be asynchronously pushed to the configured miner API in the background. Depending on the miner response, the state will transition to &quot;pushed&quot; or &quot;failed&quot;.&quot;pushed&quot; - If the state is specified as &quot;pushed&quot;, this tells Txbox the transaction is already accepted by miners. In the background, Txbox will poll the configured miner API until a response confirms the transaction is in a block.The miner API queue and processing occurs automatically in a background process, run under your application's supervision tree. For details refer to Txbox.Mapi.Queue and Txbox.Mapi.Processor.Each historic miner API response is saved associated to the transaction. The most recent response is always preloaded with the transaction. This allows you to inspect any messages or errors given by miners.iex&gt; {:ok, tx} = Txbox.find(&quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) iex&gt; tx.status %Txbox.Transactions.MapiResponse{ type: &quot;push&quot;, payload: %{ &quot;return_result&quot; =&gt; &quot;failure&quot;, &quot;return_description&quot; =&gt; &quot;Not enough fees&quot;, ... }, public_key: &quot;03e92d3e5c3f7bd945dfbf48e7a99393b1bfb3f11f380ae30d286e7ff2aec5a270&quot;, signature: &quot;3045022100c8e7f9369545b89c978afc13cc19fc6dd6e1cd139d363a6b808141e2c9fccd2e02202e12f4bf91d10bf7a45191e6fe77f50d7b5351dae7e0613fecc42f61a5736af8&quot;, verified: true }","ref":"Txbox.html","title":"Txbox","type":"module"},{"doc":"Finds a list of transactions, scoped by the specified channel and/or filtered by the map of query options.If the channel is omitted, it defaults to default_channel/0. Alernatively, the channel can be specified as &quot;_&quot; which is the TXT syntax for the global scope.Query optionsThe accepted query options are: (keys can be atoms or strings):search - Full text search made on trasactions' tags and meta data:tagged - Filter transactions by the given tag or tags:from - The block height from which to filter transactions by:to - The block height to which to filter transactions by:at - The block height at which to filter transactions by exactly:order - The attribute to sort transactions by:limit - The maximum number of transactions to return:offset - The start offset from which to return transactions (for pagination):rawtx - Include the full rawtx in the query response (defaults false)ExamplesFind all transactions from the specified block height in the default channel (&quot;txbox&quot;)iex&gt; Txbox.all(%{from: 636400}) {:ok, [%Tx{}, ...]}Find all transactions in the specified channel with a combination of filtersiex&gt; Txbox.all(&quot;photos&quot;, %{from: 636400, tagged: &quot;hubble&quot;, limit: 5}) {:ok, [%Tx{}, ...]}Find all transactions in any channel unfilterediex&gt; Txbox.all(&quot;_&quot;) {:ok, [%Tx{}, ...]}Make full text search against the transactions' meta data and tag names.iex&gt; Txbox.all(%{search: &quot;hubble deep field&quot;}) {:ok, [%Tx{}, ...]}","ref":"Txbox.html#all/2","title":"Txbox.all/2","type":"function"},{"doc":"Adds the given transaction parameters into Txbox, within the specified channel.If the channel is omitted, it defaults to default_channel/0.ExamplesAdd a transaction txid within the default channel (&quot;txbox&quot;).iex&gt; Txbox.create(%{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot; ...&gt; }) {:ok, %Tx{}}Add a transaction with associated meta data, within a specified channel.iex&gt; Txbox.create(&quot;photos&quot;, %{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;, ...&gt; tags: [&quot;hubble&quot;, &quot;universe&quot;], ...&gt; meta: %{ ...&gt; title: &quot;Hubble Ultra-Deep Field&quot; ...&gt; }, ...&gt; data: %{ ...&gt; bitfs: &quot;https://x.bitfs.network/6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110.out.0.3&quot; ...&gt; } ...&gt; }) {:ok, %Tx{}}","ref":"Txbox.html#create/2","title":"Txbox.create/2","type":"function"},{"doc":"Returns the default channel (&quot;txbox&quot;).","ref":"Txbox.html#default_channel/0","title":"Txbox.default_channel/0","type":"function"},{"doc":"Finds a transaction by it's txid, scoped by the specified channel.If the channel is omitted, it defaults to default_channel/0. Alernatively, the channel can be specified as &quot;_&quot; which is the TXT syntax for the global scope.OptionsThe accepted options are::rawtx - Include the full rawtx in the query response (defaults false)ExamplesFind within the default channel (&quot;txbox&quot;)iex&gt; Txbox.find(&quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) {:ok, %Tx{}}Find within the specified channeliex&gt; Txbox.find(&quot;photos&quot;, &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) {:ok, %Tx{}}Find within the global scopeiex&gt; Txbox.find(&quot;_&quot;, &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) {:ok, %Tx{}}","ref":"Txbox.html#find/3","title":"Txbox.find/3","type":"function"},{"doc":"Starts the Txbox process linked to the current process.","ref":"Txbox.html#start_link/1","title":"Txbox.start_link/1","type":"function"},{"doc":"Updates the given transaction with the updated parameters.It is only possible to update &quot;pending&quot; state transactions, otherwise the function will return an error.Examplesiex&gt; {:ok, tx} = Txbox.create(%{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;, ...&gt; meta: %{title: &quot;Hubble Ultra-Deep Field&quot;} ...&gt; }) iex&gt; iex&gt; Txbox.update(tx, %{ ...&gt; tags: [&quot;hubble&quot;, &quot;universe&quot;] ...&gt; }) {:ok, %Tx{ txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;, tags: [&quot;hubble&quot;, &quot;universe&quot;], meta: %{ title: &quot;Hubble Ultra-Deep Field&quot; } }}","ref":"Txbox.html#update/2","title":"Txbox.update/2","type":"function"},{"doc":"Collection of functions for composing Ecto queries.The functions in this module can be broadly split into two types, expressions and queries.ExpressionsExpression functions can be used to compose queries following the Elixir pipeline syntax.iex&gt; Tx ...&gt; |&gt; Transactions.confirmed(true) ...&gt; |&gt; Transactions.tagged([&quot;space&quot;, &quot;photos&quot;]) %Ecto.Query{}QueriesQuery functions interface with the repo and either create or return records from the repo.iex&gt; Transactions.list_tx() [%Tx{}, ...]","ref":"Txbox.Transactions.html","title":"Txbox.Transactions","type":"module"},{"doc":"Query by the given channel name.","ref":"Txbox.Transactions.html#channel/2","title":"Txbox.Transactions.channel/2","type":"function"},{"doc":"Query by the transaction confirmation status.","ref":"Txbox.Transactions.html#confirmed/2","title":"Txbox.Transactions.confirmed/2","type":"function"},{"doc":"Creates a transaction from the given params.Returns an :ok / :error tuple response.Examplesiex&gt; {:ok, tx} = Transactions.create_tx(%{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;, ...&gt; channel: &quot;mychannel&quot; ...&gt; })","ref":"Txbox.Transactions.html#create_tx/1","title":"Txbox.Transactions.create_tx/1","type":"function"},{"doc":"Deletes the given transaction from the repo.Returns an :ok / :error tuple response.Examplesiex&gt; {:ok, tx} = Transactions.get_tx(&quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) ...&gt; |&gt; Transactions.delete_tx","ref":"Txbox.Transactions.html#delete_tx/1","title":"Txbox.Transactions.delete_tx/1","type":"function"},{"doc":"Get a transaction by it's internal ID or TXID.Can optionally pass a Ecto.Queryable.t as the first argument to compose queries.Examples# Find a tx by it&#39;s Txbox uuid iex&gt; tx = Transactions.find_tx &quot;e9d356cf-47e9-47c3-bfc8-c12673877302&quot; # Composed query, found by txid iex&gt; tx = Transactions.channel(&quot;mychannel) ...&gt; |&gt; Transactions.confirmed(true) ...&gt; |&gt; Transactions.find_tx(&quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;)","ref":"Txbox.Transactions.html#get_tx/2","title":"Txbox.Transactions.get_tx/2","type":"function"},{"doc":"Returns a list of transactions.Can optionally pass a Ecto.Queryable.t as the first argument to compose queries. If a map of query options is given as a secndon argument, the query is filtered by those arguments.Examplesiex&gt; txns = Transactions.channel(&quot;mychannel) ...&gt; |&gt; Transactions.confirmed(true) ...&gt; |&gt; Transactions.list_tx","ref":"Txbox.Transactions.html#list_tx/2","title":"Txbox.Transactions.list_tx/2","type":"function"},{"doc":"Returns a list of transactions that must be pushed or have their status confirmed by mAPI.This is used internally by Txbox.Mapi.Queue to fetch transactions for automatic processing.OptionsThe accepted options are::max_status_attempts - How many times to poll mAPI for confirmation status. Defaults to 20.:retry_status_after - Number of seconds before polling mAPI for confirmation status. Defaults to 300 (5 minutes).","ref":"Txbox.Transactions.html#list_tx_for_mapi/1","title":"Txbox.Transactions.list_tx_for_mapi/1","type":"function"},{"doc":"Query by the given query map.","ref":"Txbox.Transactions.html#query/2","title":"Txbox.Transactions.query/2","type":"function"},{"doc":"Returns the application's configured Repo.Ensure your application's Repo is configured in config.exs:config :txbox, repo: MyApp.Repo","ref":"Txbox.Transactions.html#repo/0","title":"Txbox.Transactions.repo/0","type":"function"},{"doc":"Search by the given term.","ref":"Txbox.Transactions.html#search/2","title":"Txbox.Transactions.search/2","type":"function"},{"doc":"Returns a list of transactions filtered by the given search term.Performs a full text search on the transactions' metadata. Can optionally pass a Ecto.Queryable.t as the first argument to compose queries.Examplesiex&gt; {:ok, txns} = Transactions.search_tx(&quot;unwriter bitpic&quot;)","ref":"Txbox.Transactions.html#search_tx/2","title":"Txbox.Transactions.search_tx/2","type":"function"},{"doc":"Query by the given tag or list of tags.Optionally tags can be specified as a comma seperated string","ref":"Txbox.Transactions.html#tagged/2","title":"Txbox.Transactions.tagged/2","type":"function"},{"doc":"Updates the transaction with the given params.Returns an :ok / :error tuple response.Examplesiex&gt; {:ok, tx} = Transactions.update_tx(tx, %{ ...&gt; meta: %{ ...&gt; title: &quot;Hubble Ultra-Deep Field&quot; ...&gt; } ...&gt; })","ref":"Txbox.Transactions.html#update_tx/2","title":"Txbox.Transactions.update_tx/2","type":"function"},{"doc":"Updates the given transaction's state.Returns an :ok / :error tuple response.Examplesiex&gt; {:ok, tx} = Transactions.update_tx_state(tx, &quot;pushed&quot;)","ref":"Txbox.Transactions.html#update_tx_state/2","title":"Txbox.Transactions.update_tx_state/2","type":"function"},{"doc":"Updates the given transaction's state, and stores the mAPI response.Returns an :ok / :error tuple response.Examplesiex&gt; {:ok, tx} = Transactions.update_tx_state(tx, &quot;pushed&quot;, mapi_response)","ref":"Txbox.Transactions.html#update_tx_state/3","title":"Txbox.Transactions.update_tx_state/3","type":"function"},{"doc":"Ensures rawtx is selected in the given query.","ref":"Txbox.Transactions.html#with_rawtx/1","title":"Txbox.Transactions.with_rawtx/1","type":"function"},{"doc":"Miner API Response schema.","ref":"Txbox.Transactions.MapiResponse.html","title":"Txbox.Transactions.MapiResponse","type":"module"},{"doc":"","ref":"Txbox.Transactions.MapiResponse.html#push_changeset/2","title":"Txbox.Transactions.MapiResponse.push_changeset/2","type":"function"},{"doc":"","ref":"Txbox.Transactions.MapiResponse.html#status_changeset/2","title":"Txbox.Transactions.MapiResponse.status_changeset/2","type":"function"},{"doc":"MAPI Response schema","ref":"Txbox.Transactions.MapiResponse.html#t:t/0","title":"Txbox.Transactions.MapiResponse.t/0","type":"type"},{"doc":"Transaction metadata embedded schema module.The transaction metadata is a structured schema for describing human readable metadata about the transaction. The following attributes can be set::title - The title of the transaction.:description - A short description of the transaction.:image - The url of an approriate preview image for the transaction.:link - The full permalink URL to access the transaction.:content - Markdown formatted content of the transaction.","ref":"Txbox.Transactions.Meta.html","title":"Txbox.Transactions.Meta","type":"module"},{"doc":"Transaction metadata schema","ref":"Txbox.Transactions.Meta.html#t:t/0","title":"Txbox.Transactions.Meta.t/0","type":"type"},{"doc":"Transaction schema module.Txbox adds a single table to your database containing all of the transaction, channel and meta data.For any transaction, the only required attribute is the txid. If no channel is specified, the transaction will be added to the Txbox.default_channel/0. Optionally any of the following attributes can be set::rawtx - The raw transaction data. Must be given as a raw binary/0, not a hex encoded string.:tags - A list of tags which can be used for organising and filtering transactions.:meta - A map containing structured metadata about the transaction. See Txbox.Transactions.Meta.t/0.:data - A map containing any other arbitarry fields.When searching Txbox, the data from :tags and :meta are incorporated into full text search.Txbox automatically syncs the transaction with your configured miner, and updates the :status attribute with a cached response from the miner's Merchant API. See t:Txbox.Transactions.Status.t/0.","ref":"Txbox.Transactions.Tx.html","title":"Txbox.Transactions.Tx","type":"module"},{"doc":"","ref":"Txbox.Transactions.Tx.html#after_transition_multi/3","title":"Txbox.Transactions.Tx.after_transition_multi/3","type":"function"},{"doc":"","ref":"Txbox.Transactions.Tx.html#before_transition/3","title":"Txbox.Transactions.Tx.before_transition/3","type":"function"},{"doc":"","ref":"Txbox.Transactions.Tx.html#transition_changeset/4","title":"Txbox.Transactions.Tx.transition_changeset/4","type":"function"},{"doc":"Transaction schema","ref":"Txbox.Transactions.Tx.html#t:t/0","title":"Txbox.Transactions.Tx.t/0","type":"type"},{"doc":"Miner API queue processor.Takes transactions one by one from the mAPI queue, and depending on the transaction state, either pushes the transaction to the miner, or checks the status of the transaction by its txid.","ref":"Txbox.Mapi.Processor.html","title":"Txbox.Mapi.Processor","type":"module"},{"doc":"Starts the Queue Processor, linked to the current process.","ref":"Txbox.Mapi.Processor.html#start_link/1","title":"Txbox.Mapi.Processor.start_link/1","type":"function"},{"doc":"Miner API background queue.Once a minute the Queue process queries the database for any transactions that should be added to the mAPI queue.","ref":"Txbox.Mapi.Queue.html","title":"Txbox.Mapi.Queue","type":"module"},{"doc":"Pushes the given transaction to the end of queue.","ref":"Txbox.Mapi.Queue.html#push/1","title":"Txbox.Mapi.Queue.push/1","type":"function"},{"doc":"Starts the Queue process, linked to the current process.","ref":"Txbox.Mapi.Queue.html#start_link/1","title":"Txbox.Mapi.Queue.start_link/1","type":"function"}]